Index: contrib/ntp/libntp/audio.c
===================================================================
--- contrib/ntp/libntp/audio.c	(版本 309693)
+++ contrib/ntp/libntp/audio.c	(版本 310419)
@@ -55,7 +55,7 @@
 #ifdef PCM_STYLE_SOUND
 # define INIT_FILE "/etc/ntp.audio"
 int agc =	SOUND_MIXER_WRITE_RECLEV; /* or IGAIN or LINE */
-int monitor =	SOUND_MIXER_WRITE_VOLUME; /* or OGAIN */
+int audiomonitor =     SOUND_MIXER_WRITE_VOLUME; /* or OGAIN */
 int devmask = 0;
 int recmask = 0;
 char cf_c_dev[100], cf_i_dev[100], cf_agc[100], cf_monitor[100];
@@ -334,7 +334,7 @@
 		/* devmask */
 		i = mixer_name(cf_monitor, devmask);
 		if (i >= 0)
-			monitor = MIXER_WRITE(i);
+                       audiomonitor = MIXER_WRITE(i);
 		else
 			printf("monitor %s not in devmask %#x\n",
 			       cf_monitor, devmask);
@@ -412,7 +412,7 @@
 # endif
 		l |= r << 8;
 		if (cf_monitor[0] != '\0')
-			rval = ioctl(ctl_fd, monitor, &l );
+                       rval = ioctl(ctl_fd, audiomonitor, &l );
 		else 
 			rval = ioctl(ctl_fd, SOUND_MIXER_WRITE_VOLUME,
 				     &l);
Index: contrib/ntp/libntp/libssl_compat.c
===================================================================
--- contrib/ntp/libntp/libssl_compat.c	(不存在的)
+++ contrib/ntp/libntp/libssl_compat.c	(版本 310419)
@@ -0,0 +1,335 @@
+/*
+ * libssl_compat.c -- OpenSSL v1.1 compatibility functions
+ *
+ * ---------------------------------------------------------------------
+ * Written by Juergen Perlinger <perlinger@ntp.org> for the NTP project
+ *
+ * Based on an idea by Kurt Roeckx <kurt@roeckx.be>
+ *
+ * ---------------------------------------------------------------------
+ * This is a clean room implementation of shim functions that have
+ * counterparts in the OpenSSL v1.1 API but not in earlier versions. So
+ * while OpenSSL broke binary compatibility with v1.1, this shim module
+ * should provide the necessary source code compatibility with older
+ * versions of OpenSSL.
+ * ---------------------------------------------------------------------
+ */
+#include "config.h"
+
+#include <string.h>
+#include <openssl/bn.h>
+#include <openssl/evp.h>
+
+#include "ntp_types.h"
+
+/* ----------------------------------------------------------------- */
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
+/* ----------------------------------------------------------------- */
+
+#include "libssl_compat.h"
+#include "ntp_assert.h"
+
+/* --------------------------------------------------------------------
+ * replace a BIGNUM owned by the caller with another one if it's not
+ * NULL, taking over the ownership of the new value. This clears & frees
+ * the old value -- the clear might be overkill, but it's better to err
+ * on the side of paranoia here.
+ */
+static void
+replace_bn_nn(
+	BIGNUM **	ps,
+	BIGNUM *	n
+	)
+{
+	if (n) {
+		REQUIRE(*ps != n);
+		BN_clear_free(*ps);
+		*ps = n;
+	}
+}
+
+/* --------------------------------------------------------------------
+ * allocation and deallocation of prime number callbacks
+ */
+BN_GENCB*
+sslshimBN_GENCB_new(void)
+{
+	return calloc(1,sizeof(BN_GENCB));
+}
+
+void
+sslshimBN_GENCB_free(
+	BN_GENCB	*cb
+	)
+{
+	free(cb);
+}
+
+/* --------------------------------------------------------------------
+ * allocation and deallocation of message digests
+ */
+EVP_MD_CTX*
+sslshim_EVP_MD_CTX_new(void)
+{
+	return calloc(1, sizeof(EVP_MD_CTX));
+}
+
+void
+sslshim_EVP_MD_CTX_free(
+	EVP_MD_CTX *	pctx
+	)
+{
+	free(pctx);
+}
+
+/* --------------------------------------------------------------------
+ * get EVP keys and key type
+ */
+int
+sslshim_EVP_PKEY_id(
+	const EVP_PKEY *pkey
+	)
+{
+	return (pkey) ? pkey->type : EVP_PKEY_NONE;
+}
+
+int
+sslshim_EVP_PKEY_base_id(
+	const EVP_PKEY *pkey
+	)
+{
+	return (pkey) ? EVP_PKEY_type(pkey->type) : EVP_PKEY_NONE;
+}
+
+RSA*
+sslshim_EVP_PKEY_get0_RSA(
+	EVP_PKEY *	pkey
+	)
+{
+	return (pkey) ? pkey->pkey.rsa : NULL;
+}
+
+DSA*
+sslshim_EVP_PKEY_get0_DSA(
+	EVP_PKEY *	pkey
+	)
+{
+	return (pkey) ? pkey->pkey.dsa : NULL;
+}
+
+/* --------------------------------------------------------------------
+ * set/get RSA params
+ */
+void
+sslshim_RSA_get0_key(
+	const RSA *	prsa,
+	const BIGNUM **	pn,
+	const BIGNUM **	pe,
+	const BIGNUM **	pd
+	)
+{
+	REQUIRE(prsa != NULL);
+
+	if (pn)
+		*pn = prsa->n;
+	if (pe)
+		*pe = prsa->e;
+	if (pd)
+		*pd = prsa->d;
+}
+
+int
+sslshim_RSA_set0_key(
+	RSA *		prsa,
+	BIGNUM *	n,
+	BIGNUM *	e,
+	BIGNUM *	d
+	)
+{
+	REQUIRE(prsa != NULL);
+	if (!((prsa->n || n) && (prsa->e || e)))
+		return 0;
+
+	replace_bn_nn(&prsa->n, n);
+	replace_bn_nn(&prsa->e, e);
+	replace_bn_nn(&prsa->d, d);
+	
+	return 1;
+}
+
+void
+sslshim_RSA_get0_factors(
+	const RSA *	prsa,
+	const BIGNUM **	pp,
+	const BIGNUM **	pq
+	)
+{
+	REQUIRE(prsa != NULL);
+
+	if (pp)
+		*pp = prsa->p;
+	if (pq)
+		*pq = prsa->q;
+}
+
+int
+sslshim_RSA_set0_factors(
+	RSA    *	prsa,
+	BIGNUM *	p,
+	BIGNUM *	q
+	)
+{
+	REQUIRE(prsa != NULL);
+	if (!((prsa->p || p) && (prsa->q || q)))
+		return 0;
+
+	replace_bn_nn(&prsa->p, p);
+	replace_bn_nn(&prsa->q, q);
+
+	return 1;
+}
+
+int
+sslshim_RSA_set0_crt_params(
+	RSA    *	prsa,
+	BIGNUM *	dmp1,
+	BIGNUM *	dmq1,
+	BIGNUM *	iqmp
+	)
+{
+	REQUIRE(prsa != NULL);
+	if (!((prsa->dmp1 || dmp1) &&
+	      (prsa->dmq1 || dmq1) &&
+	      (prsa->iqmp || iqmp) ))
+		return 0;
+
+	replace_bn_nn(&prsa->dmp1, dmp1);
+	replace_bn_nn(&prsa->dmq1, dmq1);
+	replace_bn_nn(&prsa->iqmp, iqmp);
+	
+	return 1;
+}
+
+/* --------------------------------------------------------------------
+ * set/get DSA signature parameters
+ */
+void
+sslshim_DSA_SIG_get0(
+	const DSA_SIG *	psig,
+	const BIGNUM **	pr,
+	const BIGNUM **	ps
+	)
+{
+	REQUIRE(psig != NULL);
+
+	if (pr != NULL)
+		*pr = psig->r;
+	if (ps != NULL)
+		*ps = psig->s;
+}
+
+int
+sslshim_DSA_SIG_set0(
+	DSA_SIG *	psig,
+	BIGNUM *	r,
+	BIGNUM *	s
+	)
+{
+	REQUIRE(psig != NULL);
+	if (!(r && s))
+		return 0;
+
+	replace_bn_nn(&psig->r, r);
+	replace_bn_nn(&psig->s, s);
+	
+	return 1;
+}
+
+/* --------------------------------------------------------------------
+ * get/set DSA parameters
+ */
+void
+sslshim_DSA_get0_pqg(
+	const DSA *	pdsa,
+	const BIGNUM **	pp,
+	const BIGNUM **	pq,
+	const BIGNUM **	pg
+	)
+{
+	REQUIRE(pdsa != NULL);
+
+	if (pp != NULL)
+		*pp = pdsa->p;
+	if (pq != NULL)
+		*pq = pdsa->q;
+	if (pg != NULL)
+		*pg = pdsa->g;
+}
+
+int
+sslshim_DSA_set0_pqg(
+	DSA *		pdsa,
+	BIGNUM *	p,
+	BIGNUM *	q,
+	BIGNUM *	g
+	)
+{
+	if (!((pdsa->p || p) && (pdsa->q || q) && (pdsa->g || g)))
+		return 0;
+
+	replace_bn_nn(&pdsa->p, p);
+	replace_bn_nn(&pdsa->q, q);
+	replace_bn_nn(&pdsa->g, g);
+
+	return 1;
+}
+
+void
+sslshim_DSA_get0_key(
+	const DSA *	pdsa,
+	const BIGNUM **	ppub_key,
+	const BIGNUM **	ppriv_key
+	)
+{
+	REQUIRE(pdsa != NULL);
+
+	if (ppub_key != NULL)
+		*ppub_key = pdsa->pub_key;
+	if (ppriv_key != NULL)
+		*ppriv_key = pdsa->priv_key;
+}
+
+int
+sslshim_DSA_set0_key(
+	DSA *		pdsa,
+	BIGNUM *	pub_key,
+	BIGNUM *	priv_key
+	)
+{
+	REQUIRE(pdsa != NULL);
+	if (!(pdsa->pub_key || pub_key))
+		return 0;
+
+	replace_bn_nn(&pdsa->pub_key, pub_key);
+	replace_bn_nn(&pdsa->priv_key, priv_key);
+
+	return 1;
+}
+
+int
+sslshim_X509_get_signature_nid(
+	const X509 *x
+	)
+{
+	return OBJ_obj2nid(x->sig_alg->algorithm);
+}
+
+/* ----------------------------------------------------------------- */
+#else /* OPENSSL_VERSION_NUMBER >= v1.1.0 */
+/* ----------------------------------------------------------------- */
+
+NONEMPTY_TRANSLATION_UNIT
+
+/* ----------------------------------------------------------------- */
+#endif
+/* ----------------------------------------------------------------- */

 属性改变: contrib/ntp/libntp/libssl_compat.c
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+FreeBSD=%H
\ No newline at end of property
Added: svn:mime-type
## -0,0 +1 ##
+text/plain
\ No newline at end of property
Index: contrib/ntp/libntp/ntp_calendar.c
===================================================================
--- contrib/ntp/libntp/ntp_calendar.c	(版本 309693)
+++ contrib/ntp/libntp/ntp_calendar.c	(版本 310419)
@@ -91,7 +91,7 @@
 /*
  *---------------------------------------------------------------------
  * replacing the 'time()' function
- * --------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 
 static systime_func_ptr systime_func = &time;
@@ -395,7 +395,7 @@
 /*
  *---------------------------------------------------------------------
  * basic calendar stuff
- * --------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 
 /* month table for a year starting with March,1st */
@@ -443,11 +443,11 @@
  */
 
 /*
- * ==================================================================
+ * ====================================================================
  *
  * General algorithmic stuff
  *
- * ==================================================================
+ * ====================================================================
  */
 
 /*
@@ -495,7 +495,7 @@
  * 32/16bit divisions and is still performant is a bit more
  * difficult. Since most usecases can be coded in a way that does only
  * require the 32-bit version a 64bit version is NOT provided here.
- * ---------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 int32_t
 ntpcal_periodic_extend(
@@ -542,8 +542,35 @@
 	return pivot;
 }
 
+/*---------------------------------------------------------------------
+ * Note to the casual reader
+ *
+ * In the next two functions you will find (or would have found...)
+ * the expression
+ *
+ *   res.Q_s -= 0x80000000;
+ *
+ * There was some ruckus about a possible programming error due to
+ * integer overflow and sign propagation.
+ *
+ * This assumption is based on a lack of understanding of the C
+ * standard. (Though this is admittedly not one of the most 'natural'
+ * aspects of the 'C' language and easily to get wrong.)
+ *
+ * see 
+ *	http://www.open-std.org/jtc1/sc22/wg14/www/docs/n1570.pdf
+ *	"ISO/IEC 9899:201x Committee Draft — April 12, 2011"
+ *	6.4.4.1 Integer constants, clause 5
+ *
+ * why there is no sign extension/overflow problem here.
+ *
+ * But to ease the minds of the doubtful, I added back the 'u' qualifiers
+ * that somehow got lost over the last years. 
+ */
+
+
 /*
- *-------------------------------------------------------------------
+ *---------------------------------------------------------------------
  * Convert a timestamp in NTP scale to a 64bit seconds value in the UN*X
  * scale with proper epoch unfolding around a given pivot or the current
  * system time. This function happily accepts negative pivot values as
@@ -553,7 +580,7 @@
  * This is also a periodic extension, but since the cycle is 2^32 and
  * the shift is 2^31, we can do some *very* fast math without explicit
  * divisions.
- *-------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 vint64
 ntpcal_ntp_to_time(
@@ -568,7 +595,7 @@
 	res.q_s = (pivot != NULL)
 		      ? *pivot
 		      : now();
-	res.Q_s -= 0x80000000;		/* unshift of half range */
+	res.Q_s -= 0x80000000u;		/* unshift of half range */
 	ntp	-= (uint32_t)JAN_1970;	/* warp into UN*X domain */
 	ntp	-= res.D_s.lo;		/* cycle difference	 */
 	res.Q_s += (uint64_t)ntp;	/* get expanded time	 */
@@ -581,7 +608,7 @@
 		  ? *pivot
 		  : now();
 	res = time_to_vint64(&tmp);
-	M_SUB(res.D_s.hi, res.D_s.lo, 0, 0x80000000);
+	M_SUB(res.D_s.hi, res.D_s.lo, 0, 0x80000000u);
 	ntp -= (uint32_t)JAN_1970;	/* warp into UN*X domain */
 	ntp -= res.D_s.lo;		/* cycle difference	 */
 	M_ADD(res.D_s.hi, res.D_s.lo, 0, ntp);
@@ -592,7 +619,7 @@
 }
 
 /*
- *-------------------------------------------------------------------
+ *---------------------------------------------------------------------
  * Convert a timestamp in NTP scale to a 64bit seconds value in the NTP
  * scale with proper epoch unfolding around a given pivot or the current
  * system time.
@@ -602,7 +629,7 @@
  * This is also a periodic extension, but since the cycle is 2^32 and
  * the shift is 2^31, we can do some *very* fast math without explicit
  * divisions.
- *-------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 vint64
 ntpcal_ntp_to_ntp(
@@ -617,7 +644,7 @@
 	res.q_s = (pivot)
 		      ? *pivot
 		      : now();
-	res.Q_s -= 0x80000000;		/* unshift of half range */
+	res.Q_s -= 0x80000000u;		/* unshift of half range */
 	res.Q_s += (uint32_t)JAN_1970;	/* warp into NTP domain	 */
 	ntp	-= res.D_s.lo;		/* cycle difference	 */
 	res.Q_s += (uint64_t)ntp;	/* get expanded time	 */
@@ -642,20 +669,20 @@
 
 
 /*
- * ==================================================================
+ * ====================================================================
  *
  * Splitting values to composite entities
  *
- * ==================================================================
+ * ====================================================================
  */
 
 /*
- *-------------------------------------------------------------------
+ *---------------------------------------------------------------------
  * Split a 64bit seconds value into elapsed days in 'res.hi' and
  * elapsed seconds since midnight in 'res.lo' using explicit floor
  * division. This function happily accepts negative time values as
  * timestamps before the respective epoch start.
- * -------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 ntpcal_split
 ntpcal_daysplit(
@@ -736,11 +763,11 @@
 }
 
 /*
- *-------------------------------------------------------------------
+ *---------------------------------------------------------------------
  * Split a 32bit seconds value into h/m/s and excessive days.  This
  * function happily accepts negative time values as timestamps before
  * midnight.
- * -------------------------------------------------------------------
+ *---------------------------------------------------------------------
  */
 static int32_t
 priv_timesplit(
@@ -773,7 +800,7 @@
 }
 
 /*
- * ---------------------------------------------------------------------
+ *---------------------------------------------------------------------
  * Given the number of elapsed days in the calendar era, split this
  * number into the number of elapsed years in 'res.hi' and the number
  * of elapsed days of that year in 'res.lo'.
@@ -1053,11 +1080,11 @@
 
 
 /*
- * ==================================================================
+ * ====================================================================
  *
  * merging composite entities
  *
- * ==================================================================
+ * ====================================================================
  */
 
 /*
@@ -1251,8 +1278,8 @@
  * Convert ELAPSED years/months/days of gregorian calendar to elapsed
  * days in year.
  *
- * Note: This will give the true difference to the start of the given year,
- * even if months & days are off-scale.
+ * Note: This will give the true difference to the start of the given
+ * year, even if months & days are off-scale.
  *---------------------------------------------------------------------
  */
 int32_t
@@ -1434,11 +1461,11 @@
 
 
 /*
- * ==================================================================
+ * ====================================================================
  *
  * extended and unchecked variants of caljulian/caltontp
  *
- * ==================================================================
+ * ====================================================================
  */
 int
 ntpcal_ntp64_to_date(
@@ -1500,11 +1527,11 @@
 
 
 /*
- * ==================================================================
+ * ====================================================================
  *
  * day-of-week calculations
  *
- * ==================================================================
+ * ====================================================================
  */
 /*
  * Given a RataDie and a day-of-week, calculate a RDN that is reater-than,
@@ -1557,7 +1584,7 @@
 }
 
 /*
- * ==================================================================
+ * ====================================================================
  *
  * ISO week-calendar conversions
  *
@@ -1601,7 +1628,7 @@
  * smallest possible powers of two, so the division can be implemented
  * as shifts if the optimiser chooses to do so.
  *
- * ==================================================================
+ * ====================================================================
  */
 
 /*
Index: contrib/ntp/libntp/ntp_intres.c
===================================================================
--- contrib/ntp/libntp/ntp_intres.c	(版本 309693)
+++ contrib/ntp/libntp/ntp_intres.c	(版本 310419)
@@ -118,6 +118,7 @@
  * is managed by the code which calls the *_complete routines.
  */
 
+
 /* === typedefs === */
 typedef struct blocking_gai_req_tag {	/* marshalled args */
 	size_t			octets;
@@ -124,8 +125,9 @@
 	u_int			dns_idx;
 	time_t			scheduled;
 	time_t			earliest;
+	int			retry;
 	struct addrinfo		hints;
-	int			retry;
+	u_int			qflags;
 	gai_sometime_callback	callback;
 	void *			context;
 	size_t			nodesize;
@@ -205,8 +207,8 @@
 static	void		scheduled_sleep(time_t, time_t,
 					dnsworker_ctx *);
 static	void		manage_dns_retry_interval(time_t *, time_t *,
-						  int *,
-						  time_t *);
+						  int *, time_t *,
+						  int/*BOOL*/);
 static	int		should_retry_dns(int, int);
 #ifdef HAVE_RES_INIT
 static	void		reload_resolv_conf(dnsworker_ctx *);
@@ -230,13 +232,14 @@
  *			  invokes provided callback completion function.
  */
 int
-getaddrinfo_sometime(
+getaddrinfo_sometime_ex(
 	const char *		node,
 	const char *		service,
 	const struct addrinfo *	hints,
 	int			retry,
 	gai_sometime_callback	callback,
-	void *			context
+	void *			context,
+	u_int			qflags
 	)
 {
 	blocking_gai_req *	gai_req;
@@ -277,6 +280,7 @@
 	gai_req->context = context;
 	gai_req->nodesize = nodesize;
 	gai_req->servsize = servsize;
+	gai_req->qflags = qflags;
 
 	memcpy((char *)gai_req + sizeof(*gai_req), node, nodesize);
 	memcpy((char *)gai_req + sizeof(*gai_req) + nodesize, service,
@@ -451,7 +455,21 @@
 	return 0;
 }
 
+int
+getaddrinfo_sometime(
+	const char *		node,
+	const char *		service,
+	const struct addrinfo *	hints,
+	int			retry,
+	gai_sometime_callback	callback,
+	void *			context
+	)
+{
+	return getaddrinfo_sometime_ex(node, service, hints, retry,
+				       callback, context, 0);
+}
 
+
 static void
 getaddrinfo_sometime_complete(
 	blocking_work_req	rtype,
@@ -470,7 +488,7 @@
 	char *			service;
 	char *			canon_start;
 	time_t			time_now;
-	int			again;
+	int			again, noerr;
 	int			af;
 	const char *		fam_spec;
 	int			i;
@@ -498,8 +516,9 @@
 				  gai_req->dns_idx, humantime(time_now)));
 		}
 	} else {
-		again = should_retry_dns(gai_resp->retcode,
-					 gai_resp->gai_errno);
+		noerr = !!(gai_req->qflags & GAIR_F_IGNDNSERR);
+		again = noerr || should_retry_dns(
+					gai_resp->retcode, gai_resp->gai_errno);
 		/*
 		 * exponential backoff of DNS retries to 64s
 		 */
@@ -528,9 +547,10 @@
 							gai_strerror(gai_resp->retcode),
 							gai_resp->retcode);
 				}
-			manage_dns_retry_interval(&gai_req->scheduled,
-			    &gai_req->earliest, &gai_req->retry,
-			    &child_ctx->next_dns_timeslot);
+			manage_dns_retry_interval(
+				&gai_req->scheduled, &gai_req->earliest,
+				&gai_req->retry, &child_ctx->next_dns_timeslot,
+				noerr);
 			if (!queue_blocking_request(
 					BLOCKING_GETADDRINFO,
 					gai_req,
@@ -826,7 +846,7 @@
 		if (gni_req->retry > 0)
 			manage_dns_retry_interval(&gni_req->scheduled,
 			    &gni_req->earliest, &gni_req->retry,
-			    &child_ctx->next_dns_timeslot);
+						  &child_ctx->next_dns_timeslot, FALSE);
 
 		if (gni_req->retry > 0 && again) {
 			if (!queue_blocking_request(
@@ -1033,19 +1053,33 @@
 	time_t *	pscheduled,
 	time_t *	pwhen,
 	int *		pretry,
-	time_t *	pnext_timeslot
+	time_t *	pnext_timeslot,
+	int		forever
 	)
 {
 	time_t	now;
 	time_t	when;
 	int	retry;
+	int	retmax;
 		
 	now = time(NULL);
 	retry = *pretry;
 	when = max(now + retry, *pnext_timeslot);
 	*pnext_timeslot = when;
-	retry = min(64, retry << 1);
 
+	/* this exponential backoff is slower than doubling up: The
+	 * sequence goes 2-3-4-6-8-12-16-24-32... and the upper limit is
+	 * 64 seconds for things that should not repeat forever, and
+	 * 1024 when repeated forever.
+	 */
+	retmax = forever ? 1024 : 64;
+	retry <<= 1;
+	if (retry & (retry - 1))
+		retry &= (retry - 1);
+	else
+		retry -= (retry >> 2);
+	retry = min(retmax, retry);
+
 	*pscheduled = now;
 	*pwhen = when;
 	*pretry = retry;
Index: contrib/ntp/libntp/ssl_init.c
===================================================================
--- contrib/ntp/libntp/ssl_init.c	(版本 309693)
+++ contrib/ntp/libntp/ssl_init.c	(版本 310419)
@@ -15,6 +15,7 @@
 #ifdef OPENSSL
 #include "openssl/err.h"
 #include "openssl/evp.h"
+#include "libssl_compat.h"
 
 void	atexit_ssl_cleanup(void);
 
@@ -62,6 +63,7 @@
 
 	INIT_SSL();
 }
+
 #endif	/* OPENSSL */
 
 
@@ -84,7 +86,6 @@
 	u_char		digest[EVP_MAX_MD_SIZE];
 	char *		upcased;
 	char *		pch;
-	EVP_MD_CTX	ctx;
 
 	/*
 	 * OpenSSL digest short names are capitalized, so uppercase the
@@ -110,8 +111,12 @@
 
 	if (NULL != pdigest_len) {
 #ifdef OPENSSL
-		EVP_DigestInit(&ctx, EVP_get_digestbynid(key_type));
-		EVP_DigestFinal(&ctx, digest, &digest_len);
+		EVP_MD_CTX	*ctx;
+
+		ctx = EVP_MD_CTX_new();
+		EVP_DigestInit(ctx, EVP_get_digestbynid(key_type));
+		EVP_DigestFinal(ctx, digest, &digest_len);
+		EVP_MD_CTX_free(ctx);
 		if (digest_len > max_digest_len) {
 			fprintf(stderr,
 				"key type %s %u octet digests are too big, max %lu\n",
Index: contrib/ntp/libntp/work_fork.c
===================================================================
--- contrib/ntp/libntp/work_fork.c	(版本 309693)
+++ contrib/ntp/libntp/work_fork.c	(版本 310419)
@@ -114,6 +114,11 @@
 
 /*
  * harvest_child_status() runs in the parent.
+ *
+ * Note the error handling -- this is an interaction with SIGCHLD.
+ * SIG_IGN on SIGCHLD on some OSes means do not wait but reap
+ * automatically. Since we're not really interested in the result code,
+ * we simply ignore the error.
  */
 static void
 harvest_child_status(
@@ -120,12 +125,13 @@
 	blocking_child *	c
 	)
 {
-	if (c->pid)
-	{
+	if (c->pid) {
 		/* Wait on the child so it can finish terminating */
 		if (waitpid(c->pid, NULL, 0) == c->pid)
 			TRACE(4, ("harvested child %d\n", c->pid));
-		else msyslog(LOG_ERR, "error waiting on child %d: %m", c->pid);
+		else if (errno != ECHILD)
+			msyslog(LOG_ERR, "error waiting on child %d: %m", c->pid);
+		c->pid = 0;
 	}
 }
 
@@ -162,7 +168,6 @@
 		close(c->resp_read_pipe);
 		c->resp_read_pipe = -1;
 	}
-	c->pid = 0;
 	c->resp_read_ctx = NULL;
 	DEBUG_INSIST(-1 == c->req_read_pipe);
 	DEBUG_INSIST(-1 == c->resp_write_pipe);
@@ -461,7 +466,10 @@
 	fflush(stdout);
 	fflush(stderr);
 
-	signal_no_reset(SIGCHLD, SIG_IGN);
+	/* [BUG 3050] setting SIGCHLD to SIG_IGN likely causes unwanted
+	 * or undefined effects. We don't do it and leave SIGCHLD alone.
+	 */
+	/* signal_no_reset(SIGCHLD, SIG_IGN); */
 
 	childpid = fork();
 	if (-1 == childpid) {
Index: contrib/ntp/libparse/clk_hopf6021.c
===================================================================
--- contrib/ntp/libparse/clk_hopf6021.c	(版本 309693)
+++ contrib/ntp/libparse/clk_hopf6021.c	(版本 310419)
@@ -113,13 +113,10 @@
 
 #define OFFS(x) format->field_offsets[(x)].offset
 #define STOI(x, y) Stoi(&buffer[OFFS(x)], y, format->field_offsets[(x)].length)
-#define hexval(x) (('0' <= (x) && (x) <= '9') ? (x) - '0' : \
-		   ('a' <= (x) && (x) <= 'f') ? (x) - 'a' + 10 : \
-		   ('A' <= (x) && (x) <= 'F') ? (x) - 'A' + 10 : \
-		   -1)
 
 static parse_cvt_fnc_t cvt_hopf6021;
 static parse_inp_fnc_t inp_hopf6021;
+static unsigned char   hexval(unsigned char);
 
 clockformat_t clock_hopf6021 =
 {
@@ -160,11 +157,11 @@
 		return CVT_FAIL|CVT_BADFMT;
 	}
 
-	clock_time->usecond   = 0;
-	clock_time->utcoffset = 0;
+	clock_time->usecond = 0;
+	clock_time->flags   = 0;
 
-	status = (u_char) hexval(buffer[OFFS(O_FLAGS)]);
-	weekday= (u_char) hexval(buffer[OFFS(O_WDAY)]);
+	status  = hexval(buffer[OFFS(O_FLAGS)]);
+	weekday = hexval(buffer[OFFS(O_WDAY)]);
 
 	if ((status == 0xFF) || (weekday == 0xFF))
 	{
@@ -171,29 +168,29 @@
 		return CVT_FAIL|CVT_BADFMT;
 	}
 
-	clock_time->flags  = 0;
-
 	if (weekday & HOPF_UTC)
 	{
-		clock_time->flags |= PARSEB_UTC;
+		clock_time->flags     |= PARSEB_UTC;
+		clock_time->utcoffset  = 0;
 	}
+	else if (status & HOPF_DST)
+	{
+		clock_time->flags     |= PARSEB_DST;
+		clock_time->utcoffset  = -2*60*60; /* MET DST */
+	}
 	else
 	{
-		if (status & HOPF_DST)
-		{
-			clock_time->flags     |= PARSEB_DST;
-			clock_time->utcoffset  = -2*60*60; /* MET DST */
-		}
-		else
-		{
-			clock_time->utcoffset  = -1*60*60; /* MET */
-		}
+		clock_time->utcoffset  = -1*60*60; /* MET */
 	}
 
-	clock_time->flags |= (status & HOPF_DSTWARN)  ? PARSEB_ANNOUNCE : 0;
-
+	if (status & HOPF_DSTWARN)
+	{
+		clock_time->flags |= PARSEB_ANNOUNCE;
+	}
+	
 	switch (status & HOPF_MODE)
 	{
+	    default:	/* dummy: we cover all 4 cases. */
 	    case HOPF_INVALID:  /* Time/Date invalid */
 		clock_time->flags |= PARSEB_POWERUP;
 		break;
@@ -205,9 +202,6 @@
 	    case HOPF_RADIO:    /* Radio clock */
 	    case HOPF_RADIOHP:  /* Radio clock high precision */
 		break;
-
-	    default:
-		return CVT_FAIL|CVT_BADFMT;
 	}
 
 	return CVT_OK;
@@ -244,6 +238,30 @@
 	}
 }
 
+/*
+ * convert a hex-digit to numeric value
+ */
+static unsigned char
+hexval(
+	unsigned char ch
+	)
+{
+	unsigned int dv;
+	
+	if ((dv = ch - '0') >= 10u)
+	{
+		if ((dv -= 'A'-'0') < 6u || (dv -= 'a'-'A') < 6u)
+		{
+			dv += 10;
+		}
+		else
+		{
+			dv = 0xFF;
+		}
+	}
+	return (unsigned char)dv;
+}
+
 #else /* not (REFCLOCK && CLOCK_PARSE && CLOCK_HOPF6021) */
 int clk_hopf6021_bs;
 #endif /* not (REFCLOCK && CLOCK_PARSE && CLOCK_HOPF6021) */
Index: contrib/ntp/ntpd/complete.conf.in
===================================================================
--- contrib/ntp/ntpd/complete.conf.in	(版本 309693)
+++ contrib/ntp/ntpd/complete.conf.in	(版本 310419)
@@ -26,7 +26,7 @@
 requestkey 12
 enable auth ntp monitor stats
 disable bclient calibrate kernel mode7 peer_clear_digest_early unpeer_crypto_early unpeer_crypto_nak_early unpeer_digest_early
-tos beacon 3600 ceiling 16 cohort 0 floor 1 maxclock 10 maxdist 1.5 minclock 3 mindist 0.001 minsane 1 orphan 16 orphanwait 300
+tos beacon 3600 ceiling 16 cohort 0 floor 1 maxclock 10 maxdist 1.5 minclock 3 mindist 0.001 minsane 1 orphan 16 orphanwait 300 bcpollbstep 3
 rlimit@HAVE_RLIMIT_MEMLOCK@@HAVE_RLIMIT_STACK@
 tinker allan 1500 dispersion 15 freq 0 huffpuff 7200 panic 1000 step 0.128 stepout 900 tick 0.01
 broadcastclient
Index: contrib/ntp/ntpd/keyword-gen-utd
===================================================================
--- contrib/ntp/ntpd/keyword-gen-utd	(版本 309693)
+++ contrib/ntp/ntpd/keyword-gen-utd	(版本 310419)
@@ -1 +1 @@
- *	 Generated 2016-05-19 06:35:34 UTC	  diff_ignore_line
+ *	 Generated 2016-11-09 11:39:28 UTC	  diff_ignore_line
Index: contrib/ntp/ntpd/ntp.conf.5man
===================================================================
--- contrib/ntp/ntpd/ntp.conf.5man	(版本 309693)
+++ contrib/ntp/ntpd/ntp.conf.5man	(版本 310419)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp.conf 5man "02 Jun 2016" "4.2.8p8" "File Formats"
+.TH ntp.conf 5man "21 Nov 2016" "4.2.8p9" "File Formats"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-OzaOIT/ag-3zaGHT)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Q_ai3f/ag-2_aa2f)
 .\"
-.\" It has been AutoGen-ed June 2, 2016 at 07:35:50 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed November 21, 2016 at 08:01:41 AM by AutoGen 5.18.5
 .\" From the definitions ntp.conf.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -2174,7 +2174,23 @@
 scheme starts all over from the beginning and
 the expanding ring shrinks to the minimum and increments
 from there while collecting all servers in scope.
+.SS Broadcast Options
+.TP 7
+.NOP \f\*[B-Font]tos\f[] [\f\*[B-Font]bcpollbstep\f[] \f\*[I-Font]gate\f[]]
+This command provides a way to delay,
+by the specified number of broadcast poll intervals,
+believing backward time steps from a broadcast server.
+Broadcast time networks are expected to be trusted.
+In the event a broadcast server's time is stepped backwards,
+there is clear benefit to having the clients notice this change
+as soon as possible.
+Attacks such as replay attacks can happen, however,
+and even though there are a number of protections built in to
+broadcast mode, attempts to perform  a replay attack are possible.
+This value defaults to 0, but can be changed
+to any number of poll intervals between 0 and 4.
 .SS Manycast Options
+.RS
 .TP 7
 .NOP \f\*[B-Font]tos\f[] [\f\*[B-Font]ceiling\f[] \f\*[I-Font]ceiling\f[] | \f\*[B-Font]cohort\f[] { \f\*[B-Font]0\f[] | \f\*[B-Font]1\f[] } | \f\*[B-Font]floor\f[] \f\*[I-Font]floor\f[] | \f\*[B-Font]minclock\f[] \f\*[I-Font]minclock\f[] | \f\*[B-Font]minsane\f[] \f\*[I-Font]minsane\f[]]
 This command affects the clock selection and clustering
@@ -2244,7 +2260,7 @@
 in an expanding-ring search.
 The default is eight
 multiples of 32 starting at 31.
-.PP
+.RE
 .SH Reference Clock Support
 The NTP Version 4 daemon supports some three dozen different radio,
 satellite and modem reference clocks plus a special pseudo-clock
@@ -2411,6 +2427,7 @@
 Except where noted,
 these options apply to all clock drivers.
 .SS Reference Clock Commands
+.RS
 .TP 7
 .NOP \f\*[B-Font]server\f[] \f[C]127.127.\f[]\f\*[I-Font]t\f[].\f\*[I-Font]u\f[] [\f\*[B-Font]prefer\f[]] [\f\*[B-Font]mode\f[] \f\*[I-Font]int\f[]] [\f\*[B-Font]minpoll\f[] \f\*[I-Font]int\f[]] [\f\*[B-Font]maxpoll\f[] \f\*[I-Font]int\f[]]
 This command can be used to configure reference clocks in
@@ -2559,8 +2576,9 @@
 command can be found in
 \fIMonitoring\f[] \fIOptions\f[].
 .RE
-.PP
+.RE
 .SH Miscellaneous Options
+.RS
 .TP 7
 .NOP \f\*[B-Font]broadcastdelay\f[] \f\*[I-Font]seconds\f[]
 The broadcast and multicast modes require a special calibration
@@ -3079,8 +3097,9 @@
 an expanding-ring search.
 The default is eight multiples of 32 starting at
 31.
-.PP
+.RE
 .SH "OPTIONS"
+.RS
 .TP
 .NOP \f\*[B-Font]\-\-help\f[]
 Display usage information and exit.
@@ -3092,7 +3111,7 @@
 Output version of program and exit.  The default mode is `v', a simple
 version.  The `c' mode will print copyright information and `n' will
 print the full copyright notice.
-.PP
+.RE
 .SH "OPTION PRESETS"
 Any option that is not marked as \fInot presettable\fP may be preset
 by loading values from environment variables named:
@@ -3103,6 +3122,7 @@
 .SH "ENVIRONMENT"
 See \fBOPTION PRESETS\fP for configuration environment variables.
 .SH FILES
+.RS
 .TP 15
 .NOP \fI/etc/ntp.conf\f[]
 the default name of the configuration file
@@ -3126,9 +3146,10 @@
 .TP 15
 .NOP \fIntp_dh\f[]
 Diffie-Hellman agreement parameters
-.PP
+.RE
 .SH "EXIT STATUS"
 One of the following exit values will be returned:
+.RS
 .TP
 .NOP 0 " (EXIT_SUCCESS)"
 Successful program execution.
@@ -3139,7 +3160,7 @@
 .NOP 70 " (EX_SOFTWARE)"
 libopts had an internal operational error.  Please report
 it to autogen-users@lists.sourceforge.net.  Thank you.
-.PP
+.RE
 .SH "SEE ALSO"
 \fCntpd\f[]\fR(1ntpdmdoc)\f[],
 \fCntpdc\f[]\fR(1ntpdcmdoc)\f[],
